

#include "net.h"



void net::clear()
{
	for(int r=0;r<maxlayers;r++)
	{
		getptrs[r]=0;
		for(int c=0;c<maxpewidth;c++)
		{
			pes[r][c].clear();
		}
	}
	putinptr=getoutptr=0;
}



net::net()
{
  //clear() is implied by constructers of each pe...
  createlinks();
}

net::~net()
{

}

void net::createlinks(prob defw)
{
	for(int r=0;r<maxlayers;r++)
	{
		for(int c=0;c<maxpewidth;c++)
		{
		  if(r!=inputlayer)
		  {
			for(int prc=0;prc<maxpewidth;prc++)
			{
				pes[r][c].inputs.add(pes[r-1][prc],defw);
			}
		  }
		}
	}
}


void net::dump()
{
	cout << "net::[" << this << "] putinptr=" << putinptr << " getoutptr=" 
		 << getoutptr << "\n";
	
	cout << "getptrs= ";
	for(int i=0;i<maxlayers;i++)
		cout << "  " << getptrs[i];
	cout << "\ninternal nodes:\n";
	for(int r=0;r<maxlayers;r++)
	for(int c=0;c<maxpewidth;c++)
	{
		cout << "\npes[" << r << "][" << c << "] [[" << &pes[r][c] << "]]\n";
		pes[r][c].dump();
	}
	cout << "\n";
}
void net::copy(net& n)
{
	for(int r=0;r<maxlayers;r++)
	for(int c=0;c<maxpewidth;c++)
	{
		pes[r][c].inputs.copywates(n.pes[r][c].inputs);
	}
}

prob net::putin(prob p)
{
	if(putinptr>=maxpewidth) return notprob;
	pes[inputlayer][putinptr].putoutput(p);
	putinptr++;
	return p;
}

prob net::getout()
{
	if(getoutptr>=maxpewidth) return notprob;
	return pes[outputlayer][getoutptr++].getoutput();
}


cgbbool net::getreset(int lyr)
{
	if(lyr<0 || lyr>=maxlayers) return false;
	getptrs[lyr]=0;
	return true;
}

pelement* net::get(int lyr)
{
	if(lyr<0 || lyr>=maxlayers) return NULL;
	if(getptrs[lyr]>=maxpewidth) return NULL;
	return &pes[ lyr ][ getptrs[lyr]++ ];
}

void net::run()
{
	for(int lyr=1;lyr<maxlayers;lyr++)
	for(int wid=0;wid<maxpewidth;wid++)
	{
//cerr << "pes[" << lyr << "][" << wid << "]="
		pes[lyr][wid].activate() 
//<< "\n"
;
	}
}





