/*Chris Busch
WARNING: need -lm flag for linking.
*/

//could put these into classes, but i fear that would needlessly 
//complicate things.


#include <stdlib.h>   //for NULL
#include <iostream.h> //for cout...
#include <math.h>     //for exp()
#include <time.h>	  //for randomizing...

#ifndef PROB_H
#define PROB_H

#include "netmain.h"

//#define bool int  //major HACK, but damnit bool isnt standardized...

enum cgbbool {false,true}; //Chris G. Busch bool



#ifdef NOFLOAT

#error "NOFLOAT not fully implemented yet. Sorry."

#include "fastfloat.h"

typedef Fastfloat prob;

#else
     typedef float prob;
#endif

const prob notprob=-10000; //BIG HACK, will be replaced by NaN stuff in future

#ifndef NOFLOAT
extern prob sigmoid(prob x,prob sigma=0);   //domain=allR range=[0,1]
extern prob sigmoidprime(prob x,prob dsigma=1);   //domain=allR range=[0,1]
#else
extern prob sigmoid(prob x,prob sigma=0);   //domain=allR range=[0,1]
extern prob sigmoidprime(prob x,prob dsigma=1);   //domain=allR range=[0,1]
#endif

extern prob linear(prob x,prob M,prob W);
extern prob sigmoid(prob x,prob M,prob W);   //domain=allR range=[0,1]
extern prob rndprob();

extern prob rndsign();  


inline prob posprob(prob p)
{
	return (p< prob(0)) ? prob(0) : p;
}

inline prob absprob(prob p)
{
	return fabs(p);
}


inline prob modprob(prob a,prob b)
{
  while(a > b) a -= b;
  while(a < -b) a += b;
  return a;
}

#ifdef __linux__
#define linux_random random
#define linux_srandom srandom
#define random RaNdOm_cBuScH
#else
#ifndef  NOSCRAMBLERND
#define random RaNdOm_cBuScH
#endif
#endif

static class Random
{
	int therand() 
	{
	#ifdef __linux__
 		return rand();
	#else
		return rand();
	#endif
	}
public:
	Random();

	void seed(int s) 
	{ 
	#ifdef __linux__
		srand(s);
	#else
		srand(s); 
	#endif
	}

	void randomize() { seed((int)time(NULL)); }

	int operator() (void)
	{ return therand(); }
	
	int operator() (int upbound)
	{ return therand()%upbound; }
	
	int sign() { return therand()%2 ? 1 : -1; }

	float percent()
	{	return (therand()%1001)/1000.0; }

} random;



#endif
//end of this file












