/*
Chris Busch
*/

#include "debughelp.h"


/*naming convention note:
	name <===> unname
	putname <===> getname //for changing 'current' screen
	setname <===> getname //setting internal var for future updates
*/

#include <signal.h>
#include "screenio.h"

screenio sio;


 sioret screenio::initkey()
{
  if(! keyactive) {
	 keyactive=1;
	 return  nodelay(stdscr,1);
   }
  return 0;
}

 sioret screenio::uninitkey()
{
  if(keyactive) {
	keyactive=0;
	return  nodelay(stdscr,0);
  }
  return 0;
}




void screenio_handler(int)  //int sig
{
  signal(SIGWINCH,screenio_handler);
  sio.haschanged=1;
}



screenio::screenio()
{
	bg=' ';
	signal(SIGWINCH,screenio_handler);
	haschanged=1;
	keyactive=active=0;
}

asioptr screenio::init()
{
  if(! active) {
	active=1;
	haschanged=1;
	asioptr r;
	r=initscr();
#ifdef USECOLORS
	start_color();
	if(!has_colors()) 
	  puts("\a\aCannot use colors");
	else
	  puts("using color!");
#endif
	nonl();
	leaveok(stdscr,1);
	keypad(stdscr,1);
	cursessigcont=signal(SIGCONT,SIG_DFL);
	signal(SIGCONT,cursessigcont);
#ifdef __linux__
//HACK
//	debugger.reinstall();
#endif
	return r;
  }
  return 0;
}

void screenio_text_handler(int) //int sig
{
  signal(SIGCONT,screenio_text_handler);
  endwin();
  fflush(stdout);
  puts("\nresuming...\n");
  fflush(stdout);
}

bool screenio::uninit()   
{
  if(active){
	active=0;
	endwin(); 
//	signal(SIGCONT,SIG_DFL);
	signal(SIGCONT,screenio_text_handler);
	return 1;
  }
  return 0;
}

/*

int screenio::setmode(int m)
{
  switch(m)
	{
	case nomode:
	  break;
	case textmode:
	  if(active)
		{
		  uninit();
		  uninitkey();
		  signal(SIGCONT,SIG_DFL);
		}
	  break;
	case cursesmode:
	  init();
	  initkey();
	  break;
	default:
	  cerr << "invalid screen io mode\n";
	}
  return 0;
}


*/



